
local mode, _, in_groups, in_gear = ...

local framix = 0

-- layers:
-- -1 - bg map
-- -0.5 - dead monster
-- 0 - bullet
-- 5 - monster
-- 10 - player
-- 100 - fg map
-- 110 - suck effect
-- 120 - explosions
-- 150 - targeting crosshair and text
-- 1000 - crosshair
-- 5000 - death


local notif = CreateFrame("Text")
notif:SetSize(60)
notif:SetColor(1, 0, 0)
notif:SetLayer(100)
notif:SetPoint("CENTER", UIParent, "CENTER")

local notifa = CreateFrame("Text")
notifa:SetSize(60)
notifa:SetColor(1, 0, 0)
notifa:SetLayer(100)
notifa:SetPoint("BOTTOM", UIParent, "CENTER")
notifa:SetPoint(0.5, nil, UIParent, 0.5, nil)

local notifb = CreateFrame("Text")
notifb:SetSize(40)
notifb:SetColor(1, 0, 0)
notifb:SetLayer(100)
notifb:SetPoint("TOP", UIParent, "CENTER")
notifb:SetPoint(0.5, nil, UIParent, 0.5, nil)


local notify_warn = ""
local notifications = {}
local function notify(text1, text2)
  table.insert(notifications, {text1, text2})
end

local lframix = -1
local nocoed = {}
local function SoundNoco(sound)
  if framix ~= lframix then
    nocoed = {}
    lframix = framix
  end
  
  if not nocoed[sound] then
    nocoed[sound] = true
    PlaySound(sound, 0.3)
  end
end



notif.Tick = coroutine.wrap(function ()
  while true do
    while #notifications == 0 do
      notif:SetText(notify_warn)
      notif:SetColor(1, 0, 0)
      coroutine.yield()
    end
    
    local nt = table.remove(notifications, 1)
    
    if nt[2] then
      notifa:SetText(nt[1])
      notifb:SetText(nt[2])
      notif:SetText("")
    else
      notifa:SetText("")
      notifb:SetText("")
      notif:SetText(nt[1])
    end
    
    notif:SetColor(1, 0, 0)
    notifa:SetColor(1, 0, 0)
    notifb:SetColor(1, 0, 0)
    
    coroutine.pause(60)
    
    for i = 1, 60 do
      notif:SetColor(1, 0, 0, (60 - i) / 60)
      notifa:SetColor(1, 0, 0, (60 - i) / 60)
      notifb:SetColor(1, 0, 0, (60 - i) / 60)
      coroutine.yield()
    end
  end
end)


ShowMouseCursor(false)

local bg = CreateFrame("Frame")
bg:SetBackgroundColor(0.1, 0.1, 0.1)
bg:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 50, 50)
bg:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -50, -50)
bg:SetCoordinateScale(0, 0, bg:GetWidth())

local bg_lower = CreateFrame("Texture", bg)
bg_lower:SetTexture("bg_lower")
bg_lower:SetLayer(-1)
bg_lower:SetPoint("CENTER", UIParent, "TOPLEFT")

local bg_upper = CreateFrame("Texture", bg)
bg_upper:SetTexture("bg_upper")
bg_upper:SetLayer(100)
bg_upper:SetPoint("CENTER", UIParent, "TOPLEFT")

local anims = {
  boom = {
    frames = 4, delay = 3
  },
  dink = {
    frames = 3, delay = 3
  }
}

Texture("boom_1")
Texture("boom_2")
Texture("boom_3")
Texture("boom_4")

local explol = CreateFrame("Frame", bg)
explol:SetLayer(120)

local function play_anim(anim, center, size)
  local cx, cy = center.x, center.y
  local an = CreateFrame("Texture", explol)
  an:SetPoint("CENTER", UIParent, "TOPLEFT", cx, cy)
  an.Tick = coroutine.wrap(function ()
    for i = 1, anims[anim].frames do
      an:SetTexture(anim .. "_" .. i)
      if size then
        an:SetSize(size)
      end
      coroutine.pause(anims[anim].delay)
    end
    
    an:Detach()
  end)
end


local ss_p_x, ss_p_y = 0, 0
local ss_d_x, ss_d_y = 0, 0
local pull = 0.3
local friction = 0.6
local function screenshake(magnitude)
  local ang = math.random() * 3.14159 * 2
  local x, y = math.sin(ang), math.cos(ang)
  ss_d_x, ss_d_y = ss_d_x + x * magnitude, ss_d_y + y * magnitude
end
local function screenshake_gx()
  return ss_p_x
end
local function screenshake_gy()
  return ss_p_y
end
local function screenshake_time(time)
  ss_p_x, ss_p_y = ss_p_x + ss_d_x * time, ss_p_y + ss_d_y * time
  ss_d_x, ss_d_y = (ss_d_x - ss_p_x * pull * time) * (1 - friction), (ss_d_y - ss_p_y * pull * time) * (1 - friction)
end



local player = CreateFrame("Frame", bg)
player:SetWidth(16)
player:SetHeight(16)

player.forcex, player.forcey = 0, 0

player.tex = CreateFrame("Texture", player)
player.tex:SetPoint("CENTER", UIParent, "TOPLEFT")
player.tex:SetTexture("player")


local function clamp(targ, siz)
  local impacted = false
  
  local xm, ym = (bg:GetWidth() - targ:GetWidth()) / 2, (bg:GetHeight() - targ:GetHeight()) / 2
  
  if targ.x < -xm then targ.x = -xm impacted = true end
  if targ.x > xm then targ.x = xm impacted = true end
  if targ.y < -ym then targ.y = -ym impacted = true end
  if targ.y > ym then targ.y = ym impacted = true end
  
  return impacted
end

player.x = 0
player.y = 0
function player:Tick()
  local speed = 3
  
  self.x, self.y = self.x + player.forcex, self.y + player.forcey
  player.forcex, player.forcey = approach(player.forcex, 0, 1), approach(player.forcey, 0, 1)
  
  if IsKeyDownFrame("w") or IsKeyDownFrame("arrow_up") then
    self.y = self.y - speed
  end
  if IsKeyDownFrame("s") or IsKeyDownFrame("arrow_down") then
    self.y = self.y + speed
  end
  if IsKeyDownFrame("a") or IsKeyDownFrame("arrow_left") then
    self.x = self.x - speed
  end
  if IsKeyDownFrame("d") or IsKeyDownFrame("arrow_right") then
    self.x = self.x + speed
  end
  
  clamp(self)

  self:SetPoint("CENTER", UIParent, "TOPLEFT", self.x, self.y)
end
player:SetLayer(10)

local deaths = {}
local bullets = {}

local ammos = {}
ammos.Antipersonnel = {}
ammos.Antipersonnel.Type = "Projectile"
ammos.Antipersonnel.Blurb = "Moderate damage"
ammos.Antipersonnel.sfx = "gunfire"
function ammos.Antipersonnel:warhead(target, eow)
  if target then
    target.health = target.health - 1
  end
  SoundNoco("impact")
  play_anim("dink", self)
  self:Die()
end
ammos.Penetrating = {}
ammos.Penetrating.Type = "Projectile"
ammos.Penetrating.Blurb = "Low damage / Travels through enemies"
ammos.Penetrating.sfx = "gunfire"
function ammos.Penetrating:warhead(target, eow)
  if target then
    target.health = target.health - 0.2
  end
  if eow then
    self:Die()
  end
end
ammos.Incendiary = {}
ammos.Incendiary.Type = "Projectile"
ammos.Incendiary.Blurb = "Low damage / Lights targets on fire"
ammos.Incendiary.sfx = "gunfire"
function ammos.Incendiary:warhead(target, eow)
  if target then
    target.health = target.health - 0.1
    target:Dot(0.5, "flame")
    SoundNoco("flamer")
  else
    SoundNoco("impact")
  end
  play_anim("dink", self)
  self:Die()
end

ammos.Grenade = {}
ammos.Grenade.Type = "Warhead"
ammos.Grenade.Blurb = "High explosion radius / Unpredictable"
ammos.Grenade.sfx = "canister"
function ammos.Grenade:warhead(target, eow)
  if self:GetWidth() < 35 then
    self:SetSize(128)
    play_anim("boom", self, self:GetWidth())
    SoundNoco("explode")
    screenshake(3)
    self.tex:SetColor(0, 0, 0, 0)
  else
    if target then
      target.health = target.health - 10
    end
  end
end
function ammos.Grenade:fuse()
  if self:GetWidth() > 35 then
    self:Die()
    self.dead = false
  end
  
  if math.random() < 0.02 then
    ammos.Grenade.warhead(self, nil)
  end
end
ammos.Rocket = {}
ammos.Rocket.Type = "Warhead"
ammos.Rocket.Blurb = "Low explosion radius"
ammos.Rocket.sfx = "canister"
function ammos.Rocket:warhead(target, eow)
  if self:GetWidth() < 35 then
    self:SetSize(64)
    play_anim("boom", self, self:GetWidth())
    SoundNoco("explode")
    screenshake(2)
    self.tex:SetColor(0, 0, 0, 0)
  else
    if target then
      target.health = target.health - 10
    end
  end
end
function ammos.Rocket:fuse()
  if self:GetWidth() > 35 then
    self:Die()
    self.dead = false
  end
end
ammos.Canister = {}
ammos.Canister.Type = "Warhead"
ammos.Canister.Blurb = "Gas clouds / Poisons enemies"
ammos.Canister.sfx = "canister"
function ammos.Canister:warhead(target, eow)
  if self:GetWidth() < 35 then
    self:SetSize(96)
    self.tex:SetTexture("gas")
    SoundNoco("gas")
    self:SetLayer(120)
    self:SetCoordinateScale(0, 0, self:GetWidth(), 0)
    self.dur = 30
    self.speedmult = 0
  else
    if target then
      target.health = target.health - 0.02
      target:Dot(0.2, "gas")
    end
  end
end
function ammos.Canister:fuse()
  if self:GetWidth() > 35 then
    self.dur = self.dur - 1
    
    self.tex:SetColor(1, 1, 1, math.pow(self.dur / 30, 0.25))
    if self.dur <= 0 then
      self:Die()
    end
  end
end

ammos.Laser = {}
ammos.Laser.Type = "Energy"
ammos.Laser.Blurb = "Moderate damage"
ammos.Laser.sfx = "laser"
function ammos.Laser:warhead(target, eow)
  if target then
    target.health = target.health - 0.5
    if math.random() < 0.5 then
      target.health = target.health - 0.5
    end
  end
  SoundNoco("impact_laser")
  play_anim("dink", self)
  self:Die()
end
function ammos.Laser:fuse()
  self.speedmult = 2
end
ammos.Wave = {}
ammos.Wave.Type = "Energy"
ammos.Wave.Blurb = "Low damage / Travels through enemies / Unpredictable movement"
ammos.Wave.sfx = "laser"
function ammos.Wave:warhead(target, eow)
  if target then
    target.health = target.health - 0.1
  end
  if eow then
    self:Die()
  end
end
function ammos.Wave:fuse()
  if not self.wave_dir then
    self.wave_dir = math.random() * 3.14159 * 2
    self.wave_bias = math.random() * 3.14159 * 2
    self.wave_speed = (math.random() * 0.75 + 0.25) * 0.2
  end
  
  self.wave_bias = self.wave_bias + self.wave_speed
  local dx, dy = math.sin(self.wave_dir) * math.sin(self.wave_bias), math.cos(self.wave_dir) * math.sin(self.wave_bias)
  self.x, self.y = self.x + dx * 5, self.y + dy * 5
end
ammos.Flame = {}
ammos.Flame.Type = "Energy"
ammos.Flame.Blurb = "Low damage / Travels through enemies / Lights enemies on fire"
ammos.Flame.sfx = "flamer"
local flame_maxlife = 30
local flame_maxsize = 30
local flame_maxdmg = 0.2
local flame_maxdot = 1
function ammos.Flame:warhead(target, eow)
  local lifp = (self.life or flame_maxlife) / flame_maxlife
  if target then
    target.health = target.health - flame_maxdmg * lifp
    target:Dot(flame_maxdot * lifp, "flame")
  end
end
function ammos.Flame:fuse()
  if not self.life then self.life = flame_maxlife end
  
  self.life = self.life - 1
  self:SetSize(30 * (flame_maxlife - self.life) / flame_maxlife + 5)
  self.tex:SetSize((30 * (flame_maxlife - self.life) / flame_maxlife + 5) * 2)
  self.tex:SetColor(1, 1, 1, math.pow(1 - (flame_maxlife - self.life) / flame_maxlife, 0.25))
  
  if self.life <= 0 then
    self:Die()
  end
end

local magazines = {}
magazines.Clip = {capacity = 100, degeneration = 1}
magazines.Clip.Type = "Projectile"
magazines.Clip.Ammodefault = "Antipersonnel"
magazines.Clip.Ammodefaultq = 50
magazines.Clip.Blurb = "Projectile ammo / Small capacity / Slow failure"
magazines.Drum = {capacity = 200, degeneration = 2}
magazines.Drum.Type = "Projectile"
magazines.Drum.Ammodefault = "Antipersonnel"
magazines.Drum.Ammodefaultq = 100
magazines.Drum.Blurb = "Projectile ammo / Large capacity / Fast failure"

magazines.Inline = {capacity = 50, degeneration = 2}
magazines.Inline.Type = "Warhead"
magazines.Inline.Ammodefault = "Rocket"
magazines.Inline.Ammodefaultq = 20
magazines.Inline.Blurb = "Warhead ammo / Small capacity / Slow failure"
magazines.Box = {capacity = 100, degeneration = 4}
magazines.Box.Type = "Warhead"
magazines.Box.Ammodefault = "Rocket"
magazines.Box.Ammodefaultq = 50
magazines.Box.Blurb = "Warhead ammo / Large capacity / Fast failure"

magazines.Battery = {capacity = 500, degeneration = 0.5}
magazines.Battery.Type = "Energy"
magazines.Battery.Ammodefault = "Laser"
magazines.Battery.Ammodefaultq = 75
magazines.Battery.Blurb = "Energy ammo / Small capacity / Slow failure"
magazines.Reactor = {capacity = 1000, degeneration = 1}
magazines.Reactor.Type = "Energy"
magazines.Reactor.Ammodefault = "Laser"
magazines.Reactor.Ammodefaultq = 150
magazines.Reactor.Blurb = "Energy ammo / Large capacity / Fast failure"



local feeds = {}
feeds.Semiauto = {event = function ()
  local status = false
  return function (clicked, hook)
    if clicked and not status then hook() end
    status = clicked
  end
end, Blurb = "Fires when you click / High firerate"}

-- 6 shots per second
feeds.Automatic = {event = function ()
  local timeout = 0
  return function (clicked, hook)
    if clicked and timeout <= 0 then hook() timeout = 10 end
    timeout = timeout - 1
  end
end, Blurb = "Fires when you hold / Low firerate"}

-- ~9 shots per second
local burst_internaldelay = 2
local burst_shots = 13
local burst_externaldelay = 90 - (burst_internaldelay * burst_shots)
feeds.Burst = {event = function ()
  local timeout = 0
  local remaining = 0
  return function (clicked, hook)
    if timeout == 0 then
      if remaining > 0 then
        hook()
        remaining = remaining - 1
        if remaining == 0 then
          timeout = burst_externaldelay
        else
          timeout = burst_internaldelay
        end
      else
        if clicked then
          hook()
          remaining = burst_shots - 1
          timeout = burst_internaldelay
        end
      end
    else
      timeout = timeout - 1
    end
  end
end, Blurb = "Fires in bursts"}

-- 15 shots per second
feeds.Gatling = {event = function ()
  local timeout = 0
  return function (clicked, hook)
    if clicked and timeout <= 0 then hook() timeout = 4 end
    timeout = timeout - 1
  end
end, Blurb = "Burns through ammo / High firerate"}

--[[-- 15 shots per second
feeds.Blast = function ()
  local timeout = 0
  return function (clicked, hook)
    if clicked and timeout <= 0 then
      for i = 1, 10 do
        hook()
      end
      timeout = 90
    end
    timeout = timeout - 1
  end
end]]



local barrels = {}
local normproj = function (speed, diversion, blurb)
  return {event = function (sx, sy, ex, ey, self)
    local dx, dy = normalize(ex - sx, ey - sy)
    if dx == 0 and dy == 0 then return end
    
    local ang = math.atan2(dx, dy)
    ang = ang + (math.random() - 0.5) * diversion
    
    dx, dy = math.sin(ang), math.cos(ang)
    
    return function ()
      self.x = self.x + dx * speed * (self.speedmult or 1)
      self.y = self.y + dy * speed * (self.speedmult or 1)
      
      self:SetCoordinateScale(0, 0, self:GetWidth(), (self.speedmult == 0 and 0 or -math.atan2(dx, dy)))
    end
  end, Blurb = blurb}
end

barrels.Standard = normproj(5, 0.2, "Slow projectile speed / Moderate spread")
barrels.Spread = normproj(8, 0.8, "High spread")
barrels.Sniper = normproj(15, 0.05, "Fast projectile speed / Low spread")

--barrels.Homing = normproj(10, 0) -- TBI
--barrels.Bunt = normproj(3, 0)

-- calculate counts
local function ci(tab)
  local ct = 0
  for _ in pairs(tab) do
    ct = ct + 1
  end
  return ct
end
local a, b, c, d = ci(ammos), ci(magazines), ci(feeds), ci(barrels)
print("ammo", a, "mag", b, "feed", c, "barrel", d, "total", a * b * c * d, "rt", a * b * c * d / 3)

local lastused = nil
local function Fire(sx, sy, ex, ey, ammo, magazine, barrel)  
  local bulet = CreateFrame("Frame", bg)
  
  local am, mag, bar = ammo, magazine, barrel.event(sx, sy, ex, ey, bulet)
  
  if not bar or not am then
    bulet:Detach()
    return false
  end
  
  local amix
  for k, v in pairs(ammos) do
    if am == v then amix = k end
  end
    
  if lastused and lastused ~= am then
    notify("Now using " .. amix .. " ammo", am.Blurb)
  end
  lastused = am
  
  local btx = CreateFrame("Texture", bulet)
  btx:SetPoint("CENTER", UIParent, "TOPLEFT")
  
  if am.Type == "Projectile" then
    btx:SetTexture("bullet")
  elseif am.Type == "Energy" then
    btx:SetTexture("laser")
  elseif am.Type == "Warhead" then
    btx:SetTexture("warhead")
  end
  
  if amix == "Flame" then
    btx:SetTexture("flame")
  end
  
  bulet.tex = btx
  
  bulet:SetWidth(8)
  bulet:SetHeight(8)
  
  bulet.x, bulet.y = sx, sy
  function bulet:Hit(target, eow)
    am.warhead(self, target, eow)
  end
  function bulet:Die()
    self.dead = true
    self:Detach()
    deaths[self] = true
  end
  
  function bulet:Tick()
    bar()
    
    if am.fuse then am.fuse(self) end
    
    if clamp(self) then self:Hit(nil, true) end
    
    self:SetPoint("CENTER", UIParent, "TOPLEFT", self.x, self.y)
  end
  bulet:Tick()
  
  bullets[bulet] = true
  
  SoundNoco(am.sfx)
  
  return true
end

-- weapon managery stuff

local magazine
local feed
local feed_inst
local barrel

local lives = 5

local integrities = {{}, 1, 1, 1}

local wmbg = CreateFrame("Frame")
wmbg:SetLayer(5)
wmbg:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -20, 20)
wmbg:SetWidth(260)

local wmbga = CreateFrame("Frame", wmbg)
wmbga:SetLayer(-1)
wmbga:SetPoint("TOPLEFT", wmbg, "TOPLEFT", -10, -10)
wmbga:SetPoint("BOTTOMRIGHT", wmbg, "BOTTOMRIGHT", 10, 10)

wmbga:SetBackgroundColor(0, 0, 0, 0.8)

local ammotext = CreateFrame("Text", wmbg)
ammotext:SetPoint("TOPRIGHT", wmbg, "TOPRIGHT")
ammotext:SetSize(20)

local magazinetext = CreateFrame("Text", wmbg)
magazinetext:SetPoint("TOPRIGHT", ammotext, "BOTTOMRIGHT")
magazinetext:SetSize(20)

local magazinepercent = CreateFrame("Text", wmbg)
magazinepercent:SetPoint("LEFT", wmbg, "LEFT")
magazinepercent:SetPoint("TOP", magazinetext, "TOP")
magazinepercent:SetSize(20)

local feedtext = CreateFrame("Text", wmbg)
feedtext:SetPoint("TOPRIGHT", magazinetext, "BOTTOMRIGHT")
feedtext:SetSize(20)

local feedpercent = CreateFrame("Text", wmbg)
feedpercent:SetPoint("LEFT", wmbg, "LEFT")
feedpercent:SetPoint("TOP", feedtext, "TOP")
feedpercent:SetSize(20)

local barreltext = CreateFrame("Text", wmbg)
barreltext:SetPoint("TOPRIGHT", feedtext, "BOTTOMRIGHT")
barreltext:SetSize(20)

local barrelpercent = CreateFrame("Text", wmbg)
barrelpercent:SetPoint("LEFT", wmbg, "LEFT")
barrelpercent:SetPoint("TOP", barreltext, "TOP")
barrelpercent:SetSize(20)

wmbg:SetPoint("BOTTOM", barreltext, "BOTTOM")

local ammowarn = false
local magawarn = false
local feedwarn = false
local barrelwarn = false

local ammo_sprites = {}
local ammo_sprites_used = {}
local asl = {}

local lbg = CreateFrame("Frame")
lbg:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 10, 10)
lbg:SetWidth(99)
lbg:SetHeight(45)
lbg:SetBackgroundColor(0, 0, 0, 0.8)
lbg:SetLayer(100)

function wmbg:Tick()
  do
    for _, v in ipairs(asl) do
      v:Hide()
    end
    
    ammo_sprites_used = {}
    asl = {}
    
    local cammo = nil
    local camcount = 0
    
    local function acquire(tex, flat)
      if not ammo_sprites_used[tex] then
        ammo_sprites_used[tex] = 0
      end
      if not ammo_sprites[tex] then
        ammo_sprites[tex] = {}
      end
      
      if ammo_sprites_used[tex] == #ammo_sprites[tex] then
        local as = CreateFrame("Texture")
        if flat then  -- hackery hackery
          as:SetTexture(tex)
        else
          as:SetTexture("ammo_" .. tex)
        end
        table.insert(ammo_sprites[tex], as)
      end
      
      ammo_sprites_used[tex] = ammo_sprites_used[tex] + 1
      return ammo_sprites[tex][ammo_sprites_used[tex]]
    end
    
    local cx = 0
    
    local function flush()
      local items = math.ceil(camcount / 5)
      
      for i = 1, items do
        local as = acquire(cammo)
        as:SetPoint(1, 0.5, ammotext, 1, 0.5, -cx, 0)
        as:SetLayer(1000 - cx)
        as:Show()
        
        table.insert(asl, as)
        
        cx = cx + 2
      end
      
      cx = cx + 10
    end
    
    for _, v in ipairs(integrities[1]) do
      if v ~= cammo then
        flush()
        
        cammo = v
        camcount = 0
      end
      
      camcount = camcount + 1
    end
    
    flush()
    
    for i = 1, lives do
      local liv = acquire("player", true)
      liv:SetPoint("TOPLEFT", UIParent, "TOPLEFT", i * 16 - 5, 20)
      liv:SetLayer(1000)
      liv:Show()
      liv:SetSize(32)
      table.insert(asl, liv)
    end
  end
  
  magazinetext:SetText(magazine)
  feedtext:SetText(feed)
  barreltext:SetText(barrel)
  
  local function sc(am, targ)
    if am > 0.5 then
      targ:SetColor(0.5, 1, 0.5)
    elseif am > 0.25 then
      targ:SetColor(1, 1, 0.5)
    else
      targ:SetColor(1, 0.5, 0.5)
    end
  end
  magazinepercent:SetText(string.format("%d%%", (integrities[2] * 100)))
  sc(integrities[2], magazinepercent)
  feedpercent:SetText(string.format("%d%%", (integrities[3] * 100)))
  sc(integrities[3], feedpercent)
  barrelpercent:SetText(string.format("%d%%", (integrities[4] * 100)))
  sc(integrities[4], barrelpercent)
  
  if (#integrities[1] / magazines[magazine].Ammodefaultq) < 0.25 and not ammowarn then
    notify("Ammo getting low!")
  end
  ammowarn = (#integrities[1] / magazines[magazine].Ammodefaultq) < 0.25
  if integrities[2] < 0.25 and not magawarn then
    notify("Magazine getting low!")
  end
  magawarn = integrities[2] < 0.25
  if integrities[3] < 0.25 and not feedwarn then
    notify("Feed getting low!")
  end
  feedwarn = integrities[3] < 0.25
  if integrities[4] < 0.25 and not barrelwarn then
    notify("Barrel getting low!")
  end
  barrelwarn = integrities[4] < 0.25
end

local function get_wep(typ, id, maga)
  if typ == "Ammo" then
    if ammos[id].Type == magazines[magazine].Type then
      for i = 1, magazines[magazine].Ammodefaultq do
        table.insert(integrities[1], id)
      end
      
      notify("Acquired " .. id .. " " .. typ, ammos[id].Blurb)
      lastused = nil
    else
      notify("Acquired unusable ammo :(")
    end
  elseif typ == "Magazine" then
    magazine = id
    integrities[2] = 1
    if integrities[1][1] and ammos[integrities[1][1]].Type ~= magazines[magazine].Type then
      integrities[1] = {}
    end
    notify("Acquired " .. id .. " " .. typ, magazines[magazine].Blurb)
    
    local ites = {}
    for k, v in pairs(ammos) do
      if v.Type == magazines[magazine].Type then
        table.insert(ites, k)
      end
    end
    print("do wat")
    get_wep("Ammo", math.random_choose(ites), true)
  elseif typ == "Feed" then
    integrities[3] = 1
    feed = id
    feed_inst = feeds[feed].event()
    notify("Acquired " .. id .. " " .. typ, feeds[feed].Blurb)
  elseif typ == "Barrel" then
    integrities[4] = 1
    barrel = id
    notify("Acquired " .. id .. " " .. typ, barrels[barrel].Blurb)
  else
    assert(false)
  end
end

local function reset_everything()
  integrities[1] = {}
  get_wep("Barrel", "Standard")
  get_wep("Feed", "Automatic")
  get_wep("Magazine", "Clip")
  integrities[1] = {}
  get_wep("Ammo", "Antipersonnel")
  get_wep("Ammo", "Antipersonnel")
  notifications = {} -- lulz
end

if in_gear then
  magazine = in_gear[1]
  feed = in_gear[2]
  barrel = in_gear[3]
  integrities = in_gear[4]
  
  lives = in_gear.lives
  
  if lives < 0 then
    level_failed = true  -- lol
  end
      
  feed_inst = feeds[feed].event()
else
  reset_everything()
end

wmbg:Tick()

local function cycle(typ)
  local chunk
  if typ == "Ammo" then
    chunk = ammos
  elseif typ == "Magazine" then
    chunk = magazines
  elseif typ == "Feed" then
    chunk = feeds
  elseif typ == "Barrel" then
    chunk = barrels
  else
    assert(false)
  end
  
  local ites = {}
  for k in pairs(chunk) do
    table.insert(ites, k)
  end
  
  get_wep(typ, math.random_choose(ites))
end


local function chrandom(biased)

  local expw = 8
  
  local options = {}
  table.insert(options, 1) -- random ammo chance
  table.insert(options, 1 + expw * (1 - integrities[2])) -- random magazine chance
  table.insert(options, 1 + expw * (1 - integrities[3])) -- random feed chance
  table.insert(options, 1 + expw * (1 - integrities[4])) -- random barrel chance
  table.insert(options, math.max(0, 1 + expw * (magazines[magazine].Ammodefaultq - #integrities[1]) / magazines[magazine].Ammodefaultq) * 2) -- random right-ammo chance
  
  if not biased then options = {3, 1, 1, 1} end
  
  print(options[1], options[2], options[3], options[4], options[5])
  
  local tot = 0
  for _, v in ipairs(options) do
    tot = tot + v
  end
  
  print("total", tot)
  tot = math.random() * tot
  print("Got", tot)
  
  local choose
  for k, v in ipairs(options) do
    tot = tot - v
    if tot < 0 then
      choose = k
      break
    end
  end
  
  local id, chunk, verbo
  if choose == 1 or choose == 5 then
    id, chunk, verbo = "Ammo", ammos, true
  elseif choose == 2 then
    id, chunk, verbo = "Magazine", magazines, true
  elseif choose == 3 then
    id, chunk, verbo = "Feed", feeds, false
  elseif choose == 4 then
    id, chunk, verbo = "Barrel", barrels, false
  end
  
  local item
  
  while true do
    local set = {}
    for v in pairs(chunk) do
      table.insert(set, v)
    end
    
    item = math.random_choose(set)
    
    if choose ~= 5 then break end
    
    if chunk[item].Type == magazines[magazine].Type then break end
  end
  
  return id, item, chunk[item], verbo
end

local function absorb(monster)
  if monster.carrying_typ then
    get_wep(monster.carrying_typ, monster.carrying_id)
  else
    local id, item = chrandom(true)
    get_wep(id, item)
  end
end

-- crosshair

local monsters = {}

local sucktarg

local crosshair = CreateFrame("Texture", bg)
crosshair:SetLayer(1000)
crosshair:SetTexture("crosshair")
function crosshair:Tick()
  --[[do
  -- works badly
    local tx, ty = GetMouse()
    local moved = false
    if tx < 0 then tx = 0 moved = true end
    if ty < 0 then ty = 0 moved = true end
    if tx >= 1024 then tx = 1023 moved = true end
    if ty >= 768 then ty = 767 moved = true end
    if moved then SetMousePosition(tx, ty) end
  end]]
  
  local x, y = bg:GetRelativeMousePosition()
  self:SetPoint("CENTER", UIParent, "TOPLEFT", x, y)
    
  if not player:IsShown() then return end
  
  local ang = math.atan2(player.x - x, player.y - y)
  player:SetCoordinateScale(0, 0, player:GetWidth(), -ang)
  
  IsKeyDownFrame("mouse_left")
  
  notify_warn = ""
  
  for k, v in ipairs(integrities) do
    if type(v) == "number" and v <= 0 then
      if k == 2 then
        notify_warn = "Your magazine is broken!"
      elseif k == 3 then
        notify_warn = "Your feed is broken!"
      elseif k == 4 then
        notify_warn = "Your barrel is broken!"
      end
    end
  end

  if #integrities[1] == 0 then
    notify_warn = "You are out of ammo!"
  end

  feed_inst(IsKeyDownFrame("mouse_left"), function ()
    for k, v in ipairs(integrities) do
      if type(v) == "number" and v <= 0 then
        SoundNoco("tik")
        return
      end
    end
    
    if not Fire(player.x, player.y, x, y, integrities[1][1] and ammos[integrities[1][1]], magazines[magazine], barrels[barrel]) then
      SoundNoco("tik")
      return
    end
    
    table.remove(integrities[1], 1)
    
    local integrot = {}
    for k = 2, 4 do
      table.insert(integrot, 0.05 + (1 - integrities[k]))
    end
    
    --integrot[1] = integrot[1] / 1.3 -- lower chance of the magazine being damaged so we can encourage more weaponry
    
    local inttot = 0
    for _, v in ipairs(integrot) do
      inttot = inttot + v
    end
    
    inttot = math.random() * inttot
    
    local dmgpos = nil
    
    for k, v in ipairs(integrot) do
      inttot = inttot - v
      if inttot < 0 then
        dmgpos = k
        break
      end
    end
    
    assert(dmgpos)
    
    integrities[dmgpos + 1] = math.max(integrities[dmgpos + 1] - 0.01 * magazines[magazine].degeneration, 0)
  end)
  
  
  -- suck
  local ebounds = 20
  if WasKeyPressed("mouse_right") then
    if sucktarg and monsters[sucktarg] then return end

    local closest = nil
    local clodist = 1000000
    
    local x, y = bg:GetRelativeMousePosition()
    for mon in pairs(monsters) do
      local sx, sy, ex, ey = mon:GetBounds()
      sx, sy, ex, ey = sx - ebounds, sy - ebounds, ex + ebounds, ey + ebounds
      if sx <= x and sy <= y and ex >= x and ey >= y then
        local dx, dy = (sx + ex) / 2 - x, (sy + ey) / 2 - y
        local dst = dx * dx + dy * dy
        
        if mon.carrying_typ then dst = dst - 1000 end
        
        if clodist > dst then
          clodist = dst
          closest = mon
        end
      end
    end
    
    if closest then
      PlaySound("suckup", 0.2)
      closest.sucking = 0
      sucktarg = closest
    end
  end
end


local healths = {
  chaff = 1,
  chaff_extra = 2,
  tank = 10,
  bomb = 0.5,
}

local monster_speed = 1.5
local function SpawnMonster(typ, sx, sy, sdx, sdy)
  --assert(typ == "chaff" or typ == "chaff_extra")
  assert(healths[typ])
  local mon = CreateFrame("Frame", bg)
  mon:SetLayer(5 + math.random())
  mon:SetSize(32)
  mon.typ = typ
  
  local monrel = CreateFrame("Frame", mon)
  monrel:SetPoint("CENTER", mon, "CENTER")
  monrel:SetSize(mon:GetWidth())
  mon.tex = CreateFrame("Texture", monrel)
  mon.tex:SetTexture("enemy_" .. typ)
  mon.tex:SetPoint("CENTER", UIParent, "TOPLEFT")
  
  local xr = 512
  local yr = 384
  
  mon.x, mon.y = lerp(sx, -xr, xr), lerp(sy, -yr, yr)
  mon.health = healths[typ]
  
  if mon.x == 0 then mon.x = mon.x + (math.random() - 0.5) * 100 end
  if mon.y == 0 then mon.y = mon.y + (math.random() - 0.5) * 100 end

  impose_standard_ai(mon)
  
  local movero = coroutine.wrap(function ()
    for i = 1, 60 do
      mon.x = mon.x + sdx * 2
      mon.y = mon.y + sdy * 2
      monrel:SetCoordinateScale(0, 0, mon:GetWidth(), -math.atan2(sdx, sdy) + 3.14159)
      coroutine.yield()
    end
    
    while true do
      local direct = math.random() < 0.2
      
      local dx, dy
      if direct then
        dx, dy = normalize(player.x - mon.x, player.y - mon.y)
      else
        local dir = math.random() * 3.14159 * 2
        dx, dy = math.sin(dir), math.cos(dir)
      end
      
      local dura = math.random() * 30 + 15
      
      for i = 1, dura do
        mon.x = mon.x + dx * monster_speed
        mon.y = mon.y + dy * monster_speed
        monrel:SetCoordinateScale(0, 0, mon:GetWidth(), -math.atan2(dx, dy) + 3.14159)
        clamp(mon)
        coroutine.yield()
      end
    end
  end)
  mon.dotacu = 0
  mon:Tick_Add(function ()
    mon:SetPoint("CENTER", UIParent, "TOPLEFT", mon.x, mon.y)
    
    if not mon.sucking then
      movero()
    end
    
    if mon.dot then
      mon.health = mon.health - mon.dot
      local pre = math.floor(mon.dotacu * 50)
      mon.dotacu = mon.dotacu + mon.dot
      local post = math.floor(mon.dotacu * 50)
      if pre ~= post then
        local sfx = CreateFrame("Texture", monrel)
        sfx:SetTexture(mon.dotimg)
        sfx:SetSize(16)
        sfx:SetPoint("CENTER", UIParent, "TOPLEFT", math.random() * mon:GetWidth() - mon:GetWidth() / 2, math.random() * mon:GetHeight() - mon:GetHeight() / 2)
        sfx:SetLayer(2)
        
        local opac = 1
        
        function sfx:Tick()
          opac = opac - 0.02
          self:SetColor(1, 1, 1, opac)
          if opac <= 0 then
            self:Detach()
          end
        end
      end
    end
    
    if mon.health <= 0 then
      mon:Detach()
      deaths[mon] = true
      
      local deth = CreateFrame("Frame", bg)
      deth:SetLayer(-0.5 + math.random() / 4)
      local x, y = mon:GetCenter()
      deth:SetPoint("CENTER", UIParent, "TOPLEFT", x, y)
      deth:SetSize(16)
      deth:SetCoordinateScale(0, 0, 16, math.random() * 3.14159 * 2)
      
      local dt = CreateFrame("Texture", deth)
      dt:SetTexture("enemy_dead")
      SoundNoco("smash_" .. math.random(4))
      dt:SetPoint("CENTER", UIParent, "TOPLEFT")
      
      if typ == "bomb" then
        print("bombploding")
        for k in pairs(monsters) do
          local dx, dy = mon.x - k.x, mon.y - k.y
          local len = math.sqrt(dx * dx + dy * dy)
          if len <= 128 then
            k.health = k.health - 10
          end
        end
        play_anim("boom", mon, 128)
        SoundNoco("explode")
        screenshake(3)
      end
    end
    
    if mon.sucking then
      if math.mod(mon.sucking, 5) == 0 then
        local sucky = CreateFrame("Texture", bg)
        sucky:SetLayer(110 + math.random())
        sucky:SetTexture("ring")
        sucky:SetSize(math.random() * 32 + 16)
        sucky:SetColor(1, 1, 1, 0.25)
        
        local speed = math.random() * 0.02 + 0.01
        
        local pos = 0
        
        local mx, my = mon.x, mon.y
        
        function sucky:Tick()
          if pos > 1 then
            sucky:Detach()
          end
          
          pos = math.max(pos, mon.suck_progression or 0)
          
          local x, y = lerp(pos, mx, player.x), lerp(pos, my, player.y)
          
          sucky:SetPoint("CENTER", UIParent, "TOPLEFT", x, y)
          
          pos = pos + speed
        end
      end
      
      mon.sucking = mon.sucking + 1
      
      if mon.sucking > 180 then
      
        local flatten = CreateFrame("Frame")
        
        PlaySound("suckslurp", 0.2)
          
        flatten.Tick = coroutine.wrap(function ()
          local ox, oy = mon.x, mon.y
          for i = 0, 1, 0.1 do
            mon.suck_progression = i
            mon.x, mon.y = lerp(i, mon.x, player.x), lerp(i, mon.y, player.y)
            coroutine.yield()
          end
          
          -- kick player
          local dx, dy = normalize(player.x - ox, player.y - oy)
          player.forcex, player.forcey = dx * 20, dy * 20
          
          flatten:Detach()
        end)
        absorb(mon)
        mon:Detach()
        deaths[mon] = true
      end
    end
  end)
  function mon:Dot(dv, img)
    dv = dv / 60
    if not self.dot or self.dot < dv then self.dot = dv end
    self.dotimg = img
  end
  
  if math.random() < 0.1 then
    local crosshair = CreateFrame("Texture", bg)
    crosshair:SetTexture("targeting")
    crosshair:SetPoint("CENTER", mon, "CENTER")
    crosshair:SetColor(0.5, 1, 0.5)
    crosshair:SetLayer(150)
    
    local tex = CreateFrame("Text", crosshair)
    tex:SetPoint("BOTTOMLEFT", crosshair, 0.5, 0)
    tex:SetColor(0.5, 1, 0.5)
    tex:SetSize(20)
    
    local typ, id, info, verbo = chrandom(false)
    
    mon.carrying_typ, mon.carrying_id = typ, id
    
    if verbo then
      tex:SetText(string.format("%s %s %s", id, info.Type, typ))
    else
      tex:SetText(string.format("%s %s", id, typ))
    end
    
    local cat
    if typ == "Ammo" then cat = 1 end
    if typ == "Magazine" then cat = 2 end
    if typ == "Feed" then cat = 3 end
    if typ == "Barrel" then cat = 4 end
    
    function crosshair:Tick()
      local phase = "green"
      local quant = integrities[cat]
      if cat == 1 then
        if magazines[magazine].Type ~= info.Type then
          quant = 1
        else
          quant = #integrities[1] / magazines[magazine].Ammodefaultq
        end
      end
      if cat == 2 then
        quant = math.min(quant, #integrities[1] / magazines[magazine].Ammodefaultq)
      end
      
      if quant < 0.5 then phase = "yellow" end
      if quant < 0.25 then phase = "red" end
      
      local r, g, b
      
      if phase == "green" then
        r, g, b = 0.5, 1, 0.5
      elseif phase == "yellow" then
        r, g, b = 1, 1, 0.5
      elseif phase == "red" then
        if math.mod(framix, 80) < 40 then
          r, g, b = 1, 0.5, 0.5
        else
          r, g, b = 1, 1, 0.5
        end
      end
      
      crosshair:SetColor(r, g, b)
      tex:SetColor(r, g, b)
    end
    
    local md = mon.Detach
    function mon:Detach()
      md(self)
      crosshair:Detach()
    end
  end
  
  mon:Tick()
  
  monsters[mon] = true
end


local spawns = {
  {0.5, 0, 0, 1},
  {0.5, 1, 0, -1},
  {0, 0.5, 1, 0},
  {1, 0.5, -1, 0},
}

local groups = {}
for _, v in ipairs(in_groups) do
  local cp = {}
  for tk, tv in pairs(v) do
    cp[tk] = tv
  end
  table.insert(groups, cp)
end

local coordinator = coroutine.wrap(function ()
  while true do
    if not groups[1] then break end
    groups[1][1] = groups[1][1] - 1 / 60
    
    if groups[1][1] <= 0 then
      local spn = table.remove(groups, 1)
      
      local dir = math.random_choose(spawns)
    
      for i = 1, spn[3] do
        SpawnMonster(spn[2], unpack(dir))
        coroutine.pause(3)
      end
    end
    
    coroutine.yield()
  end
  
  while true do
    -- check to see if we've won
    coroutine.yield()
  end
end)

local spawner = coroutine.wrap(function()
  while true do
    if #groups == 0 then
      coroutine.pause(5)
      local onlychaff = true
      for k in pairs(monsters) do
        if k.typ ~= "chaff" then
          onlychaff = false
          break
        end
      end
      if onlychaff then
        break
      end
    end
    
    local dir = math.random_choose(spawns)
    
    for i = 1, 8 do
      SpawnMonster("chaff", unpack(dir))
      coroutine.pause(3)
    end
    
    local delayed = 0
    while true do
      coroutine.yield()
      local monc = 0
      for _ in pairs(monsters) do
        monc = monc + 1
      end
      if monc < 4 or delayed > 900 then
        break
      end
      delayed = delayed + 1
    end
  end
  
  while true do
    local nobody = true
    for k in pairs(monsters) do
      nobody = false
      break
    end
    
    if nobody then
      level_complete = {magazine, feed, barrel, integrities, lives = lives}
    end
    
    coroutine.yield()
  end
end)

local explo

function tick_loop(...)
  spawner()
  coordinator()
  if explo then explo() end
  
  local impact
  for m in pairs(monsters) do
    for b in pairs(bullets) do
      if collide(m, b) then
        b:Hit(m)
        
        if b.dead then break end
      end
    end
    
    if collide(m, player) then
      impact = true
    end
  end
  
  if impact and not explo then
    explo = coroutine.wrap(function ()
      SoundNoco("playerdeath")
      
      lives = lives - 1
      
      local expl = CreateFrame("Texture", bg)
      expl:SetPoint("CENTER", player, "CENTER")
      expl:SetTexture("explo")
      expl:SetLayer(5000)
      coroutine.yield()
      
      expl:SetSize(512)
      coroutine.yield()
      
      expl:Detach()
      local bewm = CreateFrame("Frame")
      bewm:SetLayer(5000)
      bewm:SetAllPoints()
      
      player:Hide()
      for m in pairs(monsters) do
        m.health = m.health - 10
      end
      
      for i = 25, 1, -1 do
        bewm:SetBackgroundColor(i, i, i, i / 25)
        coroutine.yield()
      end
      
      bewm:Detach()
      
      coroutine.pause(30)
      
      if lives < 0 then
        level_failed = true
        
        while true do coroutine.yield() end
      end
      
      player.x = 0
      player.y = 0
      player:Tick()
      reset_everything()
      player:Show()
      
      explo = nil
    end)
  end
  
  for k in pairs(deaths) do
    monsters[k] = nil
    bullets[k] = nil
  end
  deaths = {}
  
  if WasKeyPressed("z") then
    cycle("Ammo")
  end
  if WasKeyPressed("x") then
    cycle("Magazine")
  end
  if WasKeyPressed("c") then
    cycle("Feed")
  end
  if WasKeyPressed("v") then
    cycle("Barrel")
  end
  
  framix = framix + 1
  
  screenshake_time(1)
  bg:SetCoordinateScale(screenshake_gx(), screenshake_gy(), bg:GetWidth()) -- setting coords here
end
